Page MenuHomePhabricator

Determine license of the content submitted to Phabricator
Closed, ResolvedPublic

Description

If we start up a new tool, it seems like it would be a good opportunity to decide a license of the content submitted by its users.

Submitted code (including actual code and commit messages) would just be under their repository's license(s).

However, the license could apply to other content (e.g. tasks, questions and answers (Ponder), mocks, etc.) unless otherwise specified.

I don't think there's a current license for Bugzilla, so the new license would have to clarify that it does not cover imported Bugzilla content.

I think CC-BY-SA 3.0 is a good candidate. That would allow e.g. importing content from the question and answer module (Ponder) or tasks (Maniphest) to MediaWiki.org (and vice-versa).

Details

Reference
fl279

Event Timeline

flimport raised the priority of this task from to Medium.Sep 12 2014, 1:34 AM
flimport set Reference to fl279.

jdforrester wrote on 2014-05-10 15:33:51 (UTC)

CC-BY-SA 3.0 seems fine (though no doubt some people will feel that another licence would probably be better). However, we should work out what the implicit licence for Bugzilla is and make sure that Legal are OK with us claiming this licence is actually true.

LuisVillaWMF wrote on 2014-05-11 16:26:49 (UTC)

Couple quick notes:

  1. The right place to do this is in a Terms of Use, which can be minimal but should probably be shown (at least in bullet-point form) during account creation. Probably need a separate bug for that (and the privacy policy).
  2. You probably want two licenses- one for code, one for content.
  3. Code license might be best described as "same license as whatever you're patching".
  4. Content code should probably be "CC BY-SA 3.0 or any later version" (any later version is written into the license, but good to put that up front as well).

LuisVillaWMF wrote on 2014-05-11 16:28:48 (UTC)

For imported content/comments from Bugzilla... hrm, I'd have to think on that one.

mattflaschen wrote on 2014-05-13 17:26:49 (UTC)

@LuisVillaWMF:

For imported content/comments from Bugzilla... hrm, I'd have to think on that one.

Yeah, I was thinking the license may have to exclude Bugzilla, etc. imports (we could have the auto-import script add a note to comment 0 noting that it's not under the standard license), but IANAL and I could be wrong.

LuisVillaWMF wrote on 2014-05-13 18:04:14 (UTC)

Will the imports from non-Bugzilla sources contain any non-code stuff? For example, will Gerrit comments/discussions come in as well?

[Tangent: I'm sad that one new tool later, after all these years I still can't just reply by email to bugs :/

qgil wrote on 2014-05-13 19:45:47 (UTC)

Will the imports from non-Bugzilla sources contain any non-code stuff? For example, will Gerrit comments/discussions come in as well?

Day 1 (our current focus) is about Bugzilla, RT, Trello, and Mingle. The Gerrit migration will come later and, as of today, we are not sure whether we will be able to import the code review history or just leave a static dump. See the details at T42.

[Tangent: I'm sad that one new tool later, after all these years I still can't just reply by email to bugs :/

Phabricator supports replies via email. We haven't set it up here in Labs.

jdforrester wrote on 2014-05-13 19:50:54 (UTC)

Will the imports from non-Bugzilla sources contain any non-code stuff? For example, will Gerrit comments/discussions come in as well?

Day 1 (our current focus) is about Bugzilla, RT, Trello, and Mingle. The Gerrit migration will come later and, as of today, we are not sure whether we will be able to import the code review history or just leave a static dump. See the details at T42.

Or to put it another way, yes – loads and loads of comments and meta-data changes, a few thousand screenshots, a few videos, some code patches, …

LuisVillaWMF wrote on 2014-05-14 00:46:39 (UTC)

Q about those imports: will they be dated simply the date of the import? Will they have their actual dates? "It depends"? :)

qgil wrote on 2014-05-14 01:12:38 (UTC)

Dates of submission of bugs, comments, etc, must be preserved.

mattflaschen wrote on 2014-05-15 04:05:42 (UTC)

LuisVillaWMF:

Q about those imports: will they be dated simply the date of the import? Will they have their actual dates? "It depends"? :)

We should be able to include the original date in the imported version. Whether the original date is shown as the actual (i.e. the position next to "Via Web") date of the Phabricator comment, or just in text, is not determined yet (as far as I know).

LuisVillaWMF wrote on 2014-05-15 04:36:03 (UTC)

I don't think that matters all that much; basically I'd like to be able to say in the terms something like "material dated before ____ may have other licenses" or something to that effect. So as long as the date is there somewhere (heck, as long as it at least uses the import date) that would be fine by me.

LuisVillaWMF wrote on 2014-05-15 04:36:51 (UTC)

I'm taking assignment of this bug (sigh, task) unless someone objects. Will also open a "draft a TOU" bug and make that block on this one.

qgil wrote on 2014-06-02 22:02:21 (UTC)

@LuisVillaWMF Is this task a blocker for the Trusted User Tool release?

LuisVillaWMF wrote on 2014-06-02 22:05:09 (UTC)

No; users there will not be submitting content, only a few checkboxes/their signature.

aklapper wrote on 2014-08-18 20:00:49 (UTC)

@LuisVillaWMF: Any news?

Generally: This ticket blocks T335 (draft Terms of Use). But T335 is not blocking Day 1 "given that none of the tools being replaced are good on this front either." Should this ticket still block Day 1?

In T279#27, @LuisVillaWMF wrote:

I'd like to be able to say in the terms something like "material dated before ____ may have other licenses"

Yes, we can determine that, comments imported from Bugzilla will state when they were originally made.

@LuisVillaWMF: So what's criteria/stuff to make up our minds in order to come to a decision for this ticket?

My IAobviouslyNAL comment:

  • Any code in Phabricator dated after $Day1 is under the license given in the header of that code file. If none is defined, GPLwhatever+ or the default/dominant license of the module/repository the patch is against is assumed?
  • Any other material in Phabricator dated after $Day1 is under CC-BY-SA 3.0? (4.0 is cooler but not backwards compatible, so we wouldn't be allowed to copy 4.0 stuff into 3.0.)
  • Material dated before $Day1 might have other licenses?
  • ...which other cases am I missing?

mattflaschen wrote on 2014-08-19 05:30:49 (UTC)

In theory it doesn't matter (the "dated before" clause would be needed either way). But in practice I worry that if this is not a blocker for Day 1, we'll never come back to it.

Rush wrote on 2014-08-27 17:08:04 (UTC)

what needs to be done here?

aklapper wrote on 2014-08-27 17:25:53 (UTC)

We need to trick @LuisVillaWMF into answering T279#37. Soon. Somehow.

qgil wrote on 2014-08-29 16:09:04 (UTC)

By the way, as of now Phabricator doesn't have a footer, which is the usual place to place licensing information, privacy, and terms of use. Should we ask upstream for their opinion on this? I'm fine launching with these links prominently featured in the homepage only, but in the mid term a minimalist footer in all pages wouldn't harm.

aklapper wrote on 2014-08-29 23:30:14 (UTC)

In T279#44, @Qgil wrote:

By the way, as of now Phabricator doesn't have a footer, which is the usual place to place licensing information, privacy, and terms of use. Should we ask upstream for their opinion on this?

Yes, but that's stuff for T431 instead of this ticket :)

aklapper wrote on 2014-09-07 13:51:01 (UTC)

Pinged Luis several times and sent troops to his desk.

Hence this ticket will very soon be removed from the blocking list.

LuisVillaWMF wrote on 2014-09-08 00:16:25 (UTC)

Sorry, I've been swamped with other time-sensitive projects the 6 weeks or so.

Yeah, you're going to have to solve T431. And we're going to need a TOU page hosted on phabricator.

The footer should say:

Text is available under the Creative Commons Attribution-ShareAlike License; code is available under the GNU General Public License or other appropriate open source licenses. By using this site, you agree to the Terms of Use and Privacy Policy. Wikipedia® is a registered trademark of the Wikimedia Foundation, Inc., a non-profit organization.

(This is mostly necessary for the privacy policy, which I thought had an open bug, but I guess not?)

The TOU page should say something like:

The Terms of Use for Wikimedia Foundation Projects govern your use of this site. In addition:
1. Code to Which You Hold the Copyright: When you submit software source code, or other material intended for inclusion in software (such as documentation or translations), to which you hold the copyright, you agree to license it under the GNU General Public License (version 2.0 or any later version).
The only exception is if the software to which you are contributing requires a different license. In that case, you agree to license any text you contribute under that particular license. For example, at the publication of this version of the phabricator Terms of Use, Visual Editor is licensed under the MIT license, so if you make contributions to Visual Editor through this site, you agree to license those contributions under the MIT license.
2. Importing Code: You may import source code that you have found elsewhere or that you have co-authored with others, but in such case you warrant that the source code is available under terms that are compatible with the GNU General Public License version 2.0 (or, as explained above, another license when exceptionally required by that software). //

I'm still pondering adding an extra clause for the pre-existing/imported content, but (1) I'm leaning against it and (2) that situation doesn't change before/after we do the import, so it shouldn't be a blocker.

(This also resolves T335 for now.)

aklapper wrote on 2014-09-08 13:13:49 (UTC)

Would it be sufficient for the start to work around T431 by linking to those documents from Phabricator's frontpage, or must those links be 1) displayed on every single page in Phabricator && 2) from the very first day on?

If we will have to fix T431 for the very first day of the production instance we will very likely have to postpone launching it this week; no capacities.

And we're going to need a TOU page hosted on phabricator.

Confused --- none of the similar links in Bugzilla is hosted on Bugzilla itself, and the "Terms of Use" footer on mediawiki.org links to wikimediafoundation.org instead; different server.
Would a link (or a redirect) in Phabricator to a protected page hosted on one of our wikis be sufficient, or are there suddenly stricter rules?

(And once this Labs instance is down it's very welcome to reply via email.)

Rush wrote on 2014-09-08 15:46:48 (UTC)

copy of email sent to keep this convo alive:

The labs Phab is scheduled to be taken down today, and there are a few outstanding issues I’m not sure about.  I’m hoping a summary email will help keep this conversation alive.  As it stands, if I read things right, we may need to delay our timeline.

Things to define:

A) license of the content submitted by its users
B) terms of use 
C) privacy policy

A —

Text is available under the Creative Commons Attribution-ShareAlike License; code is available under the GNU General Public License or other appropriate open source licenses. By using this site, you agree to the Terms of Use and Privacy Policy. Wikipedia® is a registered trademark of the Wikimedia Foundation, Inc., a non-profit organization.

B —

The Terms of Use for Wikimedia Foundation Projects govern your use of this site. In addition:
1. Code to Which You Hold the Copyright: When you submit software source code, or other material intended for inclusion in software (such as documentation or translations), to which you hold the copyright, you agree to license it under the GNU General Public License (version 2.0 or any later version).
The only exception is if the software to which you are contributing requires a different license. In that case, you agree to license any text you contribute under that particular license. For example, at the publication of this version of the phabricator Terms of Use, Visual Editor is licensed under the MIT license, so if you make contributions to Visual Editor through this site, you agree to license those contributions under the MIT license.
2. Importing Code: You may import source code that you have found elsewhere or that you have co-authored with others, but in such case you warrant that the source code is available under terms that are compatible with the GNU General Public License version 2.0 (or, as explained above, another license when exceptionally required by that software). //

C --

Link to https://wikimediafoundation.org/wiki/Privacy_policy ?  Same as bugzilla or full text?

Complications...

Where to put them?  

Phabricator does not have a footer in the same way bugzilla does.  I inquired with the main upstream person (epriestley) and it seems this cannot be easily done for all pages.  Some pages are not “pages” but applications which don’t allow scrolling with trello like interfaces, etc.  So having a universal footer isn’t something that can happen this week, and is generally a sizable question mark for implementation.

Local text or links to wiki?

Bugzilla seems to link to mediawiki for these items, is that a viable option for Phabricator as well?

Near-Term options:

* We can modify the ‘homepage’ of phabricator with any links / content we want.  We currently have an example ‘Terms’ content box that would house these links.  We could spell out the full text of anything needed.

* We can provide custom HTML on the ‘login’ page.  There really isn’t a registration, per say, as we don’t allow local accounts. We only link to our existing SUL and LDAP providers.

————————

I am including a screenshot of the kind of thing we can do with the homepage, a screenshot of the current ‘login page’ for legalpad, and pdf copies of the current tickets where this has been discussed.  If our near-term options do not suffice I think we are back to the drawing board on this for a bit.  There is the possibility of modifying the header with content like Bugzilla, but since that is a link to the wiki I’m not sure that is sufficient here.  In talking with Evan, it seems making an icon on the header with a drop down to these items may be a straightforward change, but that seems less likely to appease.  The header space is also not reserved in this case, and the header arrangement will likely be a point of contention with ongoing upgrades.

Thanks for any help,
Chase
In T171#24, @flimport wrote:

LuisVillaWMF wrote on 2014-09-08 00:16:25 (UTC)
Yeah, you're going to have to solve T263. And we're going to need a TOU page hosted on phabricator.

T198: Draft a terms of use

The footer should say:
Text is available under the Creative Commons Attribution-ShareAlike License; code is available under the GNU General Public License or other appropriate open source licenses. By using this site, you agree to the Terms of Use and Privacy Policy. Wikipedia® is a registered trademark of the Wikimedia Foundation, Inc., a non-profit organization.

Ok, if we can style this minimally (font size), then it would be good to make it look just like the footer of Wikipedia i.e. https://en.wikipedia.org/wiki/Main_Page

The TOU page should say something like:

Moved to T198#18

Qgil raised the priority of this task from Medium to High.Sep 21 2014, 3:59 PM

High priority because this task is blocking the opening of the registration to all wikimedians.

Qgil added a comment.Sep 23 2014, 7:53 AM

The footer now contains license information. I have edited the footer manually, which probably is not a right thing to do in general, but I really want to remove blockers for T463. I will leave this task open until the changes are properly applied via Puppet.

In T171#37, @Qgil wrote:

I will leave this task open until the changes are properly applied via Puppet.

Patch in https://gerrit.wikimedia.org/r/#/c/162219/ (hope I did everything right when it comes to encoding etc)

Qgil added a subscriber: jeremyb.Sep 28 2014, 5:30 PM
In T171#40, @Qgil wrote:

Resolved upstream. Will be fixed here as soon as we update our version of Phabricator (before Day 1, I guess).

Qgil added a comment.Sep 29 2014, 6:50 AM
In T263#17, @jeremyb wrote:

should we also do something to prevent a line wrap in the middle of "Wikimedia Foundation"? I guess just make it   should be sufficient. (for me, sometimes wraps there, sometimes doesn't)

Good point.

Qgil added a comment.EditedSep 29 2014, 6:55 AM

For your information Krenair asked on IRC why do we need to specify

Wikipedia® is a registered trademark of the Wikimedia Foundation, Inc.

I asked Luis Villa. "Wikipedia" is not mentioned anywhere in the Pabricator URL, homepage, or UI strings. Only if someone mentions Wikipedia in a task will this term appear. I will report the answer here.

can this be closed now?

Qgil added a comment.Sep 29 2014, 6:10 PM

It says "Wikipedia\u00ae" (the TM was escaped, I guess).

I still didn't receive a reply from Luis about getting rid of the "Wikipedia..." sentence altogether.

Please, let's wait one day (at most) to see whether we need to fix the TM or remove the sentence.

I cleaned up the '\u00ae' anyway for now. Open to whatever in the future tho.

Qgil closed this task as Resolved.Sep 29 2014, 7:54 PM
Qgil assigned this task to chasemp.
Qgil set Security to None.

Thanks! I will create a new task if the Legal team wants any change in the current footer.

chasemp mentioned this in Unknown Object (Diffusion Commit).Nov 15 2014, 1:01 AM
chasemp mentioned this in Unknown Object (Diffusion Commit).Dec 10 2014, 8:37 PM